'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _slicedToArray(arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i['return']) _i['return'](); } finally { if (_d) throw _e; } } return _arr; } else { throw new TypeError('Invalid attempt to destructure non-iterable instance'); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

var _cluster = require('cluster');

var _cluster2 = _interopRequireDefault(_cluster);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _options = require('../options');

var _options2 = _interopRequireDefault(_options);

var _Worker = require('./Worker');

var _Worker2 = _interopRequireDefault(_Worker);

var Workers = (function () {
  function Workers() {
    _classCallCheck(this, Workers);

    this.workers = [];
    this.next = 0;
    this.matches = Object.create(null);
    this.defaultWorkers = 2;
  }

  _createClass(Workers, [{
    key: 'available',
    value: function available() {
      return this.workers.length > 0;
    }
  }, {
    key: 'count',
    value: function count() {
      return this.workers.length;
    }
  }, {
    key: 'spawn',
    value: function spawn(number) {
      var _this = this;

      // Spawns worker processes. If `number` is not defined, 2 workers are spawned

      number = number || this.defaultWorkers;

      _lodash2['default'].range(number).forEach(function () {
        _this.workers.push(new _Worker2['default']());
      });
    }
  }, {
    key: 'build',
    value: function build(opts, cb) {
      // Passes `opts` to an available worker

      opts = (0, _options2['default'])(opts);

      if (!this.available()) {
        return cb(new Error('No workers available'));
      }

      var matchedWorker = this.match(opts);
      if (matchedWorker) {
        return matchedWorker.build(opts, cb);
      }

      var _get = this.get(opts);

      var _get2 = _slicedToArray(_get, 2);

      var err = _get2[0];
      var worker = _get2[1];

      if (err) return cb(err, null);

      this.matches[opts.buildHash] = worker.id;
      worker.build(opts, cb);
    }
  }, {
    key: 'match',
    value: function match(opts) {
      // Returns a worker, if any, which has previously built `opts` and is likely
      // to have a warm compiler or an in-memory cache

      var key = opts.buildHash;
      var id = this.matches[key];
      if (id) {
        return _lodash2['default'].find(this.workers, { id: id });
      }
    }
  }, {
    key: 'get',
    value: function get(opts) {
      // Returns the next available worker who can handle the build

      var current = this.next;

      do {
        var worker = this.workers[this.next];

        this.next++;
        if (this.next >= this.workers.length) {
          this.next = 0;
        }

        if (worker.canHandle(opts)) {
          return [null, worker];
        }
      } while (this.next != current);

      return [new Error('No workers are available who can safely handle ' + opts.config + '. Restart the process or add more workers'), null];
    }
  }, {
    key: 'killAll',
    value: function killAll() {
      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = this.workers[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var worker = _step.value;

          worker.kill();
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator['return']) {
            _iterator['return']();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }

      this.workers = [];
      this.next = 0;
      this.matches = Object.create(null);
    }
  }]);

  return Workers;
})();

exports['default'] = new Workers();
module.exports = exports['default'];
//# sourceMappingURL=index.js.map